% file to compile the vcg pretty-printer %

set_search_path(  (library_pathname() ^ `/string/`)
                . (library_pathname() ^ `/finite_sets/`)
                . search_path());;

load_theory `vcg`;;

% First, load in the parser; this is NECESSARY because the parser
  as defined CHANGES the escape character from \ to @, and the
  vcg pretty-printer code expects this setting for the escape char.  %

loadf `vcg_parser`;;


% The following loads in the whole prettyp library; but this is too much,
includes the whole prettyprinter compiler which we don't need, and
also installs the new pretty-printer as the standard HOL printer,
which is incredibly slow.

load_library `prettyp`;;

So instead, we do the following:
%

loadf (library_pathname() ^ `/prettyp/PP_printer`);;

let path st = library_pathname() ^ `/prettyp/PP_hol/` ^ st
and flag = get_flag_value `print_lib`
in  map (\st. load(path st, flag))
        [`hol_trees`;
         `precedence`;
         `hol_type_pp`;
         `hol_term_pp`;
         `hol_thm_pp`;
         `new_printers`];;

set_search_path( (sunrise_dir ^ `vcg_prettyp/`)
                . `/vcg_prettyp/`
                . search_path());;
loadf `finite_sets_pp`;;

compilef `vcg_pp`;;

quit();;
