% --------------------------------------------------------------------- %
% Define the third example program: odd and even numbers.		%
% --------------------------------------------------------------------- %

g [[ program
        procedure odd(var a; val n);
           pre  true;
           post (?b.^n = 2*b + a) /\ a < 2 /\ n = ^n;
           calls odd  with n < ^n;
           calls even with n < ^n;
           recurses   with n < ^n;

           if n = 0 then a:=0
           else if n = 1 then even(a; n-1)
                         else odd (a; n-2)
                fi
           fi
        end procedure;

        procedure even(var a; val n);
           pre  true;
           post (?b.^n + 1 = 2*b + a) /\ a < 2 /\ n = ^n;
           calls even with n < ^n;
           calls odd  with n < ^n;
           recurses   with n < ^n;

           if n = 0 then a:=1
           else if n = 1 then odd (a; n-1)
                         else even(a; n-2)
                fi
           fi
        end procedure;

        odd(a; 5)

     end program
     [ a = 1 ]
  ]];;

e(VCG_TAC);;

% 4197.5s = 1 hour, 9 min, 57.5 sec %

%<
OK..
For procedure `odd`,

By the "ASSIGN" rule, we have
   [[ {(?b. ^n = 2 * b + 0) /\ 0 < 2 /\ n = ^n}
       a := 0
      {(?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "CALL" rule, we have
   [[ {(true /\ n - 1 < ^n) /\
       (!a n2.
         (?b. (n - 1) + 1 = 2 * b + a) /\ a < 2 /\ n2 = n - 1 ==>
         (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n)}
       even(a;n - 1)
      {(?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "CALL" rule, we have
   [[ {(true /\ n - 2 < ^n) /\
       (!a n2. (?b. n - 2 = 2 * b + a) /\ a < 2 /\ n2 = n - 2 ==>
               (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n)}
       odd(a;n - 2)
      {(?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "IF" rule, we have
   [[ {(n = 1
          => (true /\ n - 1 < ^n) /\
             (!a n2.
               (?b. (n - 1) + 1 = 2 * b + a) /\
               a < 2 /\
               n2 = n - 1 ==> (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n)
           | (true /\ n - 2 < ^n) /\
             (!a n2.
               (?b. n - 2 = 2 * b + a) /\ a < 2 /\ n2 = n - 2 ==>
               (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n))}
       if n = 1 then even(a;n - 1) else odd(a;n - 2) fi
      {(?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "IF" rule, we have
   [[ {(n = 0 => (?b. ^n = 2 * b + 0) /\ 0 < 2 /\ n = ^n
           | (n = 1 => (true /\ n - 1 < ^n) /\
                       (!a n2. (?b. (n - 1) + 1 = 2 * b + a) /\
                               a < 2 /\
                               n2 = n - 1 ==>
                               (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n)
                 | (true /\ n - 2 < ^n) /\
                   (!a n2. (?b. n - 2 = 2 * b + a) /\
                           a < 2 /\
                           n2 = n - 2 ==>
                           (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n)))}
       if n = 0
          then a := 0
          else if n = 1 then even(a;n - 1) else odd(a;n - 2) fi
       fi
      {(?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By precondition strengthening, we have
   [[ {(^a = a /\ ^n = n /\ true) /\ true}
       if n = 0
          then a := 0
          else if n = 1 then even(a;n - 1) else odd(a;n - 2) fi
       fi
      {(?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n} ]]
with additional verification condition
   [[ {(^a = a /\ ^n = n /\ true) /\ true ==>
       (n = 0 => (?b. ^n = 2 * b + 0) /\ 0 < 2 /\ n = ^n
           | (n = 1
                => (true /\ n - 1 < ^n) /\
                   (!a n2. (?b. (n - 1) + 1 = 2 * b + a) /\
                           a < 2 /\
                           n2 = n - 1 ==>
                           (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n)
                 | (true /\ n - 2 < ^n) /\
                   (!a n2. (?b. n - 2 = 2 * b + a) /\
                           a < 2 /\
                           n2 = n - 2 ==>
                           (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n)))} ]]

For procedure `even`,

By the "ASSIGN" rule, we have
   [[ {(?b. ^n + 1 = 2 * b + 1) /\ 1 < 2 /\ n = ^n}
       a := 1
      {(?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "CALL" rule, we have
   [[ {(true /\ n - 1 < ^n) /\
       (!a n2. (?b. n - 1 = 2 * b + a) /\ a < 2 /\ n2 = n - 1 ==>
               (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n)}
       odd(a;n - 1)
      {(?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "CALL" rule, we have
   [[ {(true /\ n - 2 < ^n) /\
       (!a n2.
         (?b. (n - 2) + 1 = 2 * b + a) /\ a < 2 /\ n2 = n - 2 ==>
         (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n)}
       even(a;n - 2)
      {(?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "IF" rule, we have
   [[ {(n = 1 => (true /\ n - 1 < ^n) /\
                 (!a n2.
                   (?b. n - 1 = 2 * b + a) /\ a < 2 /\ n2 = n - 1 ==>
                   (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n)
           | (true /\ n - 2 < ^n) /\
             (!a n2. (?b. (n - 2) + 1 = 2 * b + a) /\
                     a < 2 /\
                     n2 = n - 2 ==>
                     (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n))}
       if n = 1 then odd(a;n - 1) else even(a;n - 2) fi
      {(?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By the "IF" rule, we have
   [[ {(n = 0 => (?b. ^n + 1 = 2 * b + 1) /\ 1 < 2 /\ n = ^n
           | (n = 1 => (true /\ n - 1 < ^n) /\
                       (!a n2.
                         (?b. n - 1 = 2 * b + a) /\
                         a < 2 /\
                         n2 = n - 1 ==>
                         (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n)
                 | (true /\ n - 2 < ^n) /\
                   (!a n2.
                     (?b. (n - 2) + 1 = 2 * b + a) /\
                     a < 2 /\
                     n2 = n - 2 ==>
                     (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n)))}
       if n = 0
          then a := 1
          else if n = 1 then odd(a;n - 1) else even(a;n - 2) fi
       fi
      {(?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n} ]]

By precondition strengthening, we have
   [[ {(^a = a /\ ^n = n /\ true) /\ true}
       if n = 0
          then a := 1
          else if n = 1 then odd(a;n - 1) else even(a;n - 2) fi
       fi
      {(?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n} ]]
with additional verification condition
   [[ {(^a = a /\ ^n = n /\ true) /\ true ==>
       (n = 0 => (?b. ^n + 1 = 2 * b + 1) /\ 1 < 2 /\ n = ^n
           | (n = 1 => (true /\ n - 1 < ^n) /\
                       (!a n2.
                         (?b. n - 1 = 2 * b + a) /\
                         a < 2 /\
                         n2 = n - 1 ==>
                         (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n)
                 | (true /\ n - 2 < ^n) /\
                   (!a n2.
                     (?b. (n - 2) + 1 = 2 * b + a) /\
                     a < 2 /\
                     n2 = n - 2 ==>
                     (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n)))} ]]

Examining the structure of the procedure call graph:

Traversing the call graph back from the procedure even:

By the call graph progress from procedure even to even, we have
   [[ {true /\ (!a n1. n1 < n ==> n1 < ^n)} even-<>->even {n < ^n} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ n = ^n ==> (!a n1. n1 < n ==> n1 < ^n)} ]]

By the call graph progress from procedure odd to even, we have
   [[ {true /\ (!a n1. n1 < n ==> n1 < ^n)} odd-<>->even {n < ^n} ]]

By the call graph progress from procedure even to odd, we have
   [[ {true /\ (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))}
      even-<>->odd
      {!a n1. n1 < n ==> n1 < ^n} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ n = ^n ==>
       (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))} ]]

By the call graph progress from procedure odd to odd, we have
   [[ {true /\ (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))}
      odd-<>->odd
      {!a n1. n1 < n ==> n1 < ^n} ]]

Generating the diversion verification condition
   [[ {(!a n1. n1 < n ==> n1 < ^n) ==>
       (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))} ]]

Traversing the call graph back from the procedure odd:

By the call graph progress from procedure even to odd, we have
   [[ {true /\ (!a n1. n1 < n ==> n1 < ^n)} even-<>->odd {n < ^n} ]]

By the call graph progress from procedure even to even, we have
   [[ {true /\ (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))}
      even-<>->even
      {!a n1. n1 < n ==> n1 < ^n} ]]

Generating the diversion verification condition
   [[ {(!a n1. n1 < n ==> n1 < ^n) ==>
       (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))} ]]

By the call graph progress from procedure odd to even, we have
   [[ {true /\ (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))}
      odd-<>->even
      {!a n1. n1 < n ==> n1 < ^n} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ n = ^n ==>
       (!a n1. n1 < n ==> (!a n2. n2 < n1 ==> n2 < ^n))} ]]

By the call graph progress from procedure odd to odd, we have
   [[ {true /\ (!a n1. n1 < n ==> n1 < ^n)} odd-<>->odd {n < ^n} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ n = ^n ==> (!a n1. n1 < n ==> n1 < ^n)} ]]

For the main body,

By the "CALL" rule, we have
   [[ {(true /\ true) /\
       (!a n1. (?b. 5 = 2 * b + a) /\ a < 2 /\ n1 = 5 ==> a = 1)}
       odd(a;5)
      {a = 1} ]]

By precondition strengthening, we have
   [[ {true} odd(a;5) {a = 1} ]]
with additional verification condition
   [[ {true ==>
       (true /\ true) /\
       (!a n1. (?b. 5 = 2 * b + a) /\ a < 2 /\ n1 = 5 ==> a = 1)} ]]

9 subgoals
"!a n1. (?b. 5 = (2 * b) + a) /\ a < 2 /\ (n1 = 5) ==> (a = 1)"

"!n ^n. (n = ^n) ==> (!a n1. n1 < n ==> n1 < ^n)"

"!n ^n. (n = ^n) ==> (!a n1. n1 < n ==> (!a' n2. n2 < n1 ==> n2 < ^n))"

"!n ^n.
  (!a n1. n1 < n ==> n1 < ^n) ==>
  (!a n1. n1 < n ==> (!a' n2. n2 < n1 ==> n2 < ^n))"

"!n ^n.
  (!a n1. n1 < n ==> n1 < ^n) ==>
  (!a n1. n1 < n ==> (!a' n2. n2 < n1 ==> n2 < ^n))"

"!n ^n. (n = ^n) ==> (!a n1. n1 < n ==> (!a' n2. n2 < n1 ==> n2 < ^n))"

"!n ^n. (n = ^n) ==> (!a n1. n1 < n ==> n1 < ^n)"

"!^a a ^n n.
  (^a = a) /\ (^n = n) ==>
  ((n = 0) => 
   ((?b. ^n + 1 = (2 * b) + 1) /\ 1 < 2 /\ (n = ^n)) | 
   ((n = 1) => 
    ((n - 1) < ^n /\
     (!a' n2.
       (?b. n - 1 = (2 * b) + a') /\ a' < 2 /\ (n2 = n - 1) ==>
       (?b. ^n + 1 = (2 * b) + a') /\ a' < 2 /\ (n = ^n))) | 
    ((n - 2) < ^n /\
     (!a' n2.
       (?b. (n - 2) + 1 = (2 * b) + a') /\ a' < 2 /\ (n2 = n - 2) ==>
       (?b. ^n + 1 = (2 * b) + a') /\ a' < 2 /\ (n = ^n)))))"

"!^a a ^n n.
  (^a = a) /\ (^n = n) ==>
  ((n = 0) => 
   ((?b. ^n = (2 * b) + 0) /\ 0 < 2 /\ (n = ^n)) | 
   ((n = 1) => 
    ((n - 1) < ^n /\
     (!a' n2.
       (?b. (n - 1) + 1 = (2 * b) + a') /\ a' < 2 /\ (n2 = n - 1) ==>
       (?b. ^n = (2 * b) + a') /\ a' < 2 /\ (n = ^n))) | 
    ((n - 2) < ^n /\
     (!a' n2.
       (?b. n - 2 = (2 * b) + a') /\ a' < 2 /\ (n2 = n - 2) ==>
       (?b. ^n = (2 * b) + a') /\ a' < 2 /\ (n = ^n)))))"

() : void
Run time: 3772.4s
Garbage collection time: 425.1s
Intermediate theorems generated: 310178

>%

%< Tactics to solve these 9 verification conditions: >%


% 1st subgoal: %

e(REPEAT GEN_TAC);;
e(DISCH_THEN REWRITE_THM);;
e(COND_CASES_TAC);;

 e(CONV_TAC (DEPTH_CONV LESS_CONV));;
 e(ASM_REWRITE_TAC[]);;
 e(CONV_TAC (ONCE_DEPTH_CONV num_CONV));;
 e(REWRITE_TAC[MULT_CLAUSES]);;
 e(EXISTS_TAC "0");;
 e(REWRITE_TAC[ADD_CLAUSES]);;

 e(MP_TAC (SPEC "n:num" LESS_0_CASES));;
 e(FIRST_ASSUM (REWRITE_THM o NOT_EQ_SYM));;
 e(DISCH_TAC);;
 e(COND_CASES_TAC);;

  e(ASM_REWRITE_TAC[SUB_EQUAL_0]);;
  e(CONV_TAC (ONCE_DEPTH_CONV LESS_CONV));;
  e(REWRITE_TAC[ADD]);;
  e(REPEAT STRIP_TAC);;
  e(EXISTS_TAC "b:num");;
  e(ASM_REWRITE_TAC[]);;

  e(ASM_REWRITE_TAC[]);;

 e(MP_TAC (SPECL["1";"n:num"] LESS_CASES));;
 e(REWRITE_TAC[LESS_OR_EQ]);;
 e(FIRST_ASSUM REWRITE_THM);;
 e(IMP_RES_THEN (REWRITE_THM o REWRITE_RULE[SYM(num_CONV "1")]) LESS_SUC_NOT);;
 e(DISCH_TAC);;
 e(FIRST_ASSUM (ASSUME_TAC o REWRITE_RULE[SYM(num_CONV "2")] o
                   MATCH_MP LESS_OR));;
 e(IMP_RES_THEN REWRITE_THM LESS_EQ_SUB_LESS);;
 e(CONJ_TAC);;

  e(ONCE_REWRITE_TAC[ADD_SYM]);;
  e(CONV_TAC (ONCE_DEPTH_CONV num_CONV));;
  e(REWRITE_TAC[LESS_ADD_SUC]);;

  e(REPEAT GEN_TAC THEN STRIP_TAC);;
  e(ASM_REWRITE_TAC[]);;
  e(EXISTS_TAC "b + 1");;
  e(REWRITE_TAC[(SYM o SPEC_ALL)ADD1]);;
  e(REWRITE_TAC[theorem `arithmetic` `MULT_SUC`]);;
  e(POP_TAC);;
  e(REWRITE_TAC[(SYM o SPEC_ALL)ADD_ASSOC]);;
  e(FIRST_ASSUM (REWRITE_THM o SYM));;
  e(ONCE_REWRITE_TAC[ADD_SYM]);;
  e(IMP_RES_THEN REWRITE_THM SUB_ADD);;

% 2nd subgoal: %

e(REPEAT GEN_TAC);;
e(DISCH_THEN REWRITE_THM);;
e(COND_CASES_TAC);;

 e(CONV_TAC (DEPTH_CONV LESS_CONV));;
 e(ASM_REWRITE_TAC[]);;
 e(EXISTS_TAC "0");;
 e(REWRITE_TAC[MULT_CLAUSES]);;

 e(MP_TAC (SPEC "n:num" LESS_0_CASES));;
 e(FIRST_ASSUM (REWRITE_THM o NOT_EQ_SYM));;
 e(DISCH_TAC);;
 e(COND_CASES_TAC);;

  e(ASM_REWRITE_TAC[SUB_EQUAL_0]);;
  e(CONV_TAC (ONCE_DEPTH_CONV LESS_CONV));;
  e(REWRITE_TAC[]);;
  e(REPEAT GEN_TAC THEN STRIP_TAC);;
  e(ASM_REWRITE_TAC[]);;
  e(EXISTS_TAC "SUC b");;
  e(CONV_TAC (ONCE_DEPTH_CONV ADD_CONV));;
  e(REWRITE_TAC[theorem `arithmetic` `MULT_SUC`]);;
  e(REWRITE_TAC[(SYM o SPEC_ALL) ADD_ASSOC]);;
  e(POP_TAC);;
  e(FIRST_ASSUM (REWRITE_THM o SYM));;
  e(REWRITE_TAC[ADD_CLAUSES]);;

 e(MP_TAC (SPECL["1";"n:num"] LESS_CASES));;
 e(REWRITE_TAC[LESS_OR_EQ]);;
 e(FIRST_ASSUM REWRITE_THM);;
 e(IMP_RES_THEN (REWRITE_THM o REWRITE_RULE[SYM(num_CONV "1")]) LESS_SUC_NOT);;
 e(DISCH_TAC);;
 e(FIRST_ASSUM (ASSUME_TAC o REWRITE_RULE[SYM(num_CONV "2")] o
                   MATCH_MP LESS_OR));;
 e(IMP_RES_THEN REWRITE_THM LESS_EQ_SUB_LESS);;
 e(CONJ_TAC);;

  e(ONCE_REWRITE_TAC[ADD_SYM]);;
  e(CONV_TAC (ONCE_DEPTH_CONV num_CONV));;
  e(REWRITE_TAC[LESS_ADD_SUC]);;

  e(REPEAT GEN_TAC THEN STRIP_TAC);;
  e(ASM_REWRITE_TAC[]);;
  e(EXISTS_TAC "SUC b");;
  e(REWRITE_TAC[theorem `arithmetic` `MULT_SUC`]);;
  e(POP_TAC);;
  e(REWRITE_TAC[(SYM o SPEC_ALL)ADD_ASSOC]);;
  e(FIRST_ASSUM (REWRITE_THM o SYM));;
  e(REWRITE_TAC[ADD_ASSOC]);;
  e(REWRITE_TAC[(SYM o SPEC_ALL)ADD1;INV_SUC_EQ]);;
  e(ONCE_REWRITE_TAC[ADD_SYM]);;
  e(IMP_RES_THEN REWRITE_THM SUB_ADD);;

% 3rd subgoal: %

e(REPEAT GEN_TAC);;
e(DISCH_THEN REWRITE_THM);;

% 4th subgoal: %

e(REPEAT GEN_TAC);;
e(DISCH_THEN (REWRITE_THM o SYM));;
e(REPEAT STRIP_TAC);;
e(IMP_RES_TAC LESS_TRANS);;

% 5th subgoal: %

e(REPEAT STRIP_TAC);;
e(RES_TAC);;
e(IMP_RES_TAC LESS_TRANS);;

% 6th subgoal: %

e(REPEAT STRIP_TAC);;
e(RES_TAC);;
e(IMP_RES_TAC LESS_TRANS);;

% 7th subgoal: %

e(REPEAT GEN_TAC);;
e(DISCH_THEN (REWRITE_THM o SYM));;
e(REPEAT STRIP_TAC);;
e(IMP_RES_TAC LESS_TRANS);;

% 8th subgoal: %

e(REPEAT GEN_TAC);;
e(DISCH_THEN (REWRITE_THM o SYM));;

% 9th subgoal (main body): %

e(REPEAT STRIP_TAC);;
e(POP_TAC);;
e(STRIP_ASSUME_TAC (SPEC "a:num" LESS_0_CASES));;

 e(UNDISCH_TAC "5 = (2 * b) + a");;
 e(POP_ASSUM (REWRITE_THM o SYM));;
 e(REWRITE_TAC[num_CONV "2"]);;
 e(REWRITE_TAC[MULT_CLAUSES;ADD_CLAUSES]);;
 e(REWRITE_TAC[num_CONV "5"]);;
 e(REWRITE_TAC[SYM(ADD_CONV "2+2")]);;
 e(REWRITE_TAC[NOT_ODD_EQ_EVEN]);;

 e(MP_TAC (SPECL["a:num";"1"] LESS_CASES));;
 e(REWRITE_TAC[LESS_OR_EQ]);;
 e(IMP_RES_TAC LESS_SUC_NOT);;
 e(POP_ASSUM (REWRITE_THM o REWRITE_RULE[num_CONV "2";LESS_MONO_EQ]));;
 e(POP_ASSUM (REWRITE_THM o REWRITE_RULE[SYM(num_CONV "1")]));;
 e(DISCH_THEN REWRITE_THM);;

let odd_even = top_thm();;
print_vcg_thm odd_even;;
%
|- [[ program
         procedure odd(a;n);
            global ;
            pre  true;
            post (?b. ^n = 2 * b + a) /\ a < 2 /\ n = ^n;
            calls odd with n < ^n;
            calls even with n < ^n;
            recurses with n < ^n;

            if n = 0
               then a := 0
               else if n = 1 then even(a;n - 1) else odd(a;n - 2) fi
            fi
         end procedure;
         procedure even(a;n);
            global ;
            pre  true;
            post (?b. ^n + 1 = 2 * b + a) /\ a < 2 /\ n = ^n;
            calls even with n < ^n;
            calls odd with n < ^n;
            recurses with n < ^n;

            if n = 0
               then a := 1
               else if n = 1 then odd(a;n - 1) else even(a;n - 2) fi
            fi
         end procedure;

         odd(a;5)
      end program
      [a = 1] ]]()
: void
Run time: 50.5s
Garbage collection time: 14.7s
%



