% --------------------------------------------------------------------- %
% Define the fifth example program: Bicycling				%
% --------------------------------------------------------------------- %

g [[ program

        procedure pedal (;val n,m);
           pre  true;
           post true;
           calls pedal with n < ^n /\ m = ^m;
           calls coast with n < ^n /\ m < ^m;
           recurses    with n < ^n;

           if 0 < n then
              if 0 < m then
                 coast(;n - 1,m - 1)
              else skip
              fi;
              pedal(;n - 1,m)
           else skip
           fi
        end procedure;

        procedure coast (;val n,m);
           pre  true;
           post true;
           calls pedal with n = ^n /\ m = ^m;
           calls coast with n = ^n /\ m < ^m;
           recurses    with m < ^m;

           pedal(;n,m);
           if 0 < m then
              coast(;n,m - 1)
           else skip
           fi
        end procedure;

        pedal(;7,12)

     end program
     [ true ]
  ]];;

e(VCG_TAC);;

% 3075.6s = 51 min, 15.6 sec %

%<
OK..
For procedure `pedal`,

By the "CALL" rule, we have
   [[ {(true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true)}
       pedal(;n - 1,m)
      {true} ]]

By the "CALL" rule, we have
   [[ {(true /\ n - 1 < ^n /\ m - 1 < ^m) /\
       (!n1 m1.
         true ==>
         (true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true))}
       coast(;n - 1,m - 1)
      {(true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true)} ]]

By the "SKIP" rule, we have
   [[ {(true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true)}
       skip
      {(true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true)} ]]

By the "IF" rule, we have
   [[ {(0 < m => (true /\ n - 1 < ^n /\ m - 1 < ^m) /\
                 (!n1 m1. true ==> (true /\ n - 1 < ^n /\ m = ^m) /\
                                   (!n m. true ==> true))
           | (true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true))}
       if 0 < m then coast(;n - 1,m - 1) else skip fi
      {(true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true)} ]]

By the "SEQ" rule, we have
   [[ {(0 < m => (true /\ n - 1 < ^n /\ m - 1 < ^m) /\
                 (!n1 m1. true ==> (true /\ n - 1 < ^n /\ m = ^m) /\
                                   (!n m. true ==> true))
           | (true /\ n - 1 < ^n /\ m = ^m) /\ (!n m. true ==> true))}
       if 0 < m then coast(;n - 1,m - 1) else skip fi; pedal(;n - 1,m)
      {true} ]]

By the "SKIP" rule, we have
   [[ {true} skip {true} ]]

By the "IF" rule, we have
   [[ {(0 < n
          => (0 < m
                => (true /\ n - 1 < ^n /\ m - 1 < ^m) /\
                   (!n1 m1. true ==> (true /\ n - 1 < ^n /\ m = ^m) /\
                                     (!n m. true ==> true))
                 | (true /\ n - 1 < ^n /\ m = ^m) /\
                   (!n m. true ==> true)) | true)}
       if 0 < n then if 0 < m then coast(;n - 1,m - 1) else skip fi;
                     pedal(;n - 1,m) else skip fi
      {true} ]]

By precondition strengthening, we have
   [[ {(^n = n /\ ^m = m /\ true) /\ true}
       if 0 < n then if 0 < m then coast(;n - 1,m - 1) else skip fi;
                     pedal(;n - 1,m) else skip fi
      {true} ]]
with additional verification condition
   [[ {(^n = n /\ ^m = m /\ true) /\ true ==>
       (0 < n => (0 < m => (true /\ n - 1 < ^n /\ m - 1 < ^m) /\
                           (!n1 m1.
                             true ==> (true /\ n - 1 < ^n /\ m = ^m) /\
                                      (!n m. true ==> true))
                     | (true /\ n - 1 < ^n /\ m = ^m) /\
                       (!n m. true ==> true)) | true)} ]]

For procedure `coast`,

By the "CALL" rule, we have
   [[ {(true /\ n = ^n /\ m - 1 < ^m) /\ (!n m. true ==> true)}
       coast(;n,m - 1)
      {true} ]]

By the "SKIP" rule, we have
   [[ {true} skip {true} ]]

By the "IF" rule, we have
   [[ {(0 < m => (true /\ n = ^n /\ m - 1 < ^m) /\ (!n m. true ==> true)
           | true)} if 0 < m then coast(;n,m - 1) else skip fi {true} ]]

By the "CALL" rule, we have
   [[ {(true /\ n = ^n /\ m = ^m) /\
       (!n1 m1. true ==> (0 < m => (true /\ n = ^n /\ m - 1 < ^m) /\
                                   (!n m. true ==> true) | true))}
       pedal(;n,m)
      {(0 < m => (true /\ n = ^n /\ m - 1 < ^m) /\ (!n m. true ==> true)
           | true)} ]]

By the "SEQ" rule, we have
   [[ {(true /\ n = ^n /\ m = ^m) /\
       (!n1 m1. true ==> (0 < m => (true /\ n = ^n /\ m - 1 < ^m) /\
                                   (!n m. true ==> true) | true))}
       pedal(;n,m); if 0 < m then coast(;n,m - 1) else skip fi
      {true} ]]

By precondition strengthening, we have
   [[ {(^n = n /\ ^m = m /\ true) /\ true}
       pedal(;n,m); if 0 < m then coast(;n,m - 1) else skip fi
      {true} ]]
with additional verification condition
   [[ {(^n = n /\ ^m = m /\ true) /\ true ==>
       (true /\ n = ^n /\ m = ^m) /\
       (!n1 m1. true ==> (0 < m => (true /\ n = ^n /\ m - 1 < ^m) /\
                                   (!n m. true ==> true) | true))} ]]

Examining the structure of the procedure call graph:

Traversing the call graph back from the procedure coast:

By the call graph progress from procedure coast to coast, we have
   [[ {true /\ (!n1 m1. n1 = n /\ m1 < m ==> m1 < ^m)}
      coast-<>->coast
      {m < ^m} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ m = ^m ==> (!n1 m1. n1 = n /\ m1 < m ==> m1 < ^m)} ]]

By the call graph progress from procedure pedal to coast, we have
   [[ {true /\ (!n1 m1. n1 < n /\ m1 < m ==> m1 < ^m)}
      pedal-<>->coast
      {m < ^m} ]]

By the call graph progress from procedure coast to pedal, we have
   [[ {true /\ (!n1 m1. n1 = n /\ m1 = m ==>
                        (!n2 m2. n2 < n1 /\ m2 < m1 ==> m2 < ^m))}
      coast-<>->pedal
      {!n1 m1. n1 < n /\ m1 < m ==> m1 < ^m} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ m = ^m ==>
       (!n1 m1. n1 = n /\ m1 = m ==>
                (!n2 m2. n2 < n1 /\ m2 < m1 ==> m2 < ^m))} ]]

By the call graph progress from procedure pedal to pedal, we have
   [[ {true /\ (!n1 m1. n1 < n /\ m1 = m ==>
                        (!n2 m2. n2 < n1 /\ m2 < m1 ==> m2 < ^m))}
      pedal-<>->pedal
      {!n1 m1. n1 < n /\ m1 < m ==> m1 < ^m} ]]

Generating the diversion verification condition
   [[ {(!n1 m1. n1 < n /\ m1 < m ==> m1 < ^m) ==>
       (!n1 m1. n1 < n /\ m1 = m ==>
                (!n2 m2. n2 < n1 /\ m2 < m1 ==> m2 < ^m))} ]]

Traversing the call graph back from the procedure pedal:

By the call graph progress from procedure coast to pedal, we have
   [[ {true /\ (!n1 m1. n1 = n /\ m1 = m ==> n1 < ^n)}
      coast-<>->pedal
      {n < ^n} ]]

By the call graph progress from procedure coast to coast, we have
   [[ {true /\ (!n1 m1. n1 = n /\ m1 < m ==>
                        (!n2 m2. n2 = n1 /\ m2 = m1 ==> n2 < ^n))}
      coast-<>->coast
      {!n1 m1. n1 = n /\ m1 = m ==> n1 < ^n} ]]

Generating the diversion verification condition
   [[ {(!n1 m1. n1 = n /\ m1 = m ==> n1 < ^n) ==>
       (!n1 m1. n1 = n /\ m1 < m ==>
                (!n2 m2. n2 = n1 /\ m2 = m1 ==> n2 < ^n))} ]]

By the call graph progress from procedure pedal to coast, we have
   [[ {true /\ (!n1 m1. n1 < n /\ m1 < m ==>
                        (!n2 m2. n2 = n1 /\ m2 = m1 ==> n2 < ^n))}
      pedal-<>->coast
      {!n1 m1. n1 = n /\ m1 = m ==> n1 < ^n} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ n = ^n ==>
       (!n1 m1. n1 < n /\ m1 < m ==>
                (!n2 m2. n2 = n1 /\ m2 = m1 ==> n2 < ^n))} ]]

By the call graph progress from procedure pedal to pedal, we have
   [[ {true /\ (!n1 m1. n1 < n /\ m1 = m ==> n1 < ^n)}
      pedal-<>->pedal
      {n < ^n} ]]

Generating the undiverted recursion verification condition
   [[ {true /\ n = ^n ==> (!n1 m1. n1 < n /\ m1 = m ==> n1 < ^n)} ]]

For the main body,

By the "CALL" rule, we have
   [[ {(true /\ true) /\ (!n m. true ==> true)} pedal(;7,12) {true} ]]

By precondition strengthening, we have
   [[ {true} pedal(;7,12) {true} ]]
with additional verification condition
   [[ {true ==> (true /\ true) /\ (!n m. true ==> true)} ]]

8 subgoals
"!m ^m n. (m = ^m) ==> (!n1 m1. (n1 = n) /\ m1 < m ==> m1 < ^m)"

"!m ^m n.
  (m = ^m) ==>
  (!n1 m1.
    (n1 = n) /\ (m1 = m) ==> (!n2 m2. n2 < n1 /\ m2 < m1 ==> m2 < ^m))"

"!n m ^m.
  (!n1 m1. n1 < n /\ m1 < m ==> m1 < ^m) ==>
  (!n1 m1.
    n1 < n /\ (m1 = m) ==> (!n2 m2. n2 < n1 /\ m2 < m1 ==> m2 < ^m))"

"!n m ^n.
  (!n1 m1. (n1 = n) /\ (m1 = m) ==> n1 < ^n) ==>
  (!n1 m1.
    (n1 = n) /\ m1 < m ==> (!n2 m2. (n2 = n1) /\ (m2 = m1) ==> n2 < ^n))"

"!n ^n m.
  (n = ^n) ==>
  (!n1 m1.
    n1 < n /\ m1 < m ==> (!n2 m2. (n2 = n1) /\ (m2 = m1) ==> n2 < ^n))"

"!n ^n m. (n = ^n) ==> (!n1 m1. n1 < n /\ (m1 = m) ==> n1 < ^n)"

"!^n n ^m m.
  (^n = n) /\ (^m = m) ==>
  ((n = ^n) /\ (m = ^m)) /\
  (!n1 m1. (0 < m => ((n = ^n) /\ (m - 1) < ^m) | T))"

"!^n n ^m m.
  (^n = n) /\ (^m = m) ==>
  (0 < n => 
   (0 < m => 
    (((n - 1) < ^n /\ (m - 1) < ^m) /\
     (!n1 m1. (n - 1) < ^n /\ (m = ^m))) | 
    ((n - 1) < ^n /\ (m = ^m))) | 
   T)"

() : void
Run time: 2760.1s
Garbage collection time: 315.5s
Intermediate theorems generated: 224220

>%

%< These verification conditions are solved by the following tactics: >%


% 1st subgoal: %

%e(REPEAT GEN_TAC);;
e(DISCH_THEN REWRITE_THM);;
e(REWRITE_TAC[SUB_RIGHT_LESS]);;
e(REWRITE_TAC[num_CONV "1";ADD_CLAUSES;LESS_SUC_REFL]);;
e(COND_CASES_TAC);;

 e(COND_CASES_TAC);;

  e(REWRITE_TAC[]);;

  e(REWRITE_TAC[]);;

 e(COND_CASES_TAC);;

  e(REWRITE_TAC[]);;

  e(REWRITE_TAC[]);;%

e(REPEAT GEN_TAC
  THEN DISCH_THEN REWRITE_THM
  THEN REWRITE_TAC[SUB_RIGHT_LESS]
  THEN REWRITE_TAC[num_CONV "1";ADD_CLAUSES;LESS_SUC_REFL]
  THEN COND_CASES_TAC
  THEN COND_CASES_TAC
  THEN REWRITE_TAC[]);;

% 2nd subgoal: %

%e(REPEAT GEN_TAC);;
e(DISCH_THEN REWRITE_THM);;
e(REWRITE_TAC[SUB_RIGHT_LESS]);;
e(REWRITE_TAC[num_CONV "1";ADD_CLAUSES;LESS_SUC_REFL]);;
e(COND_CASES_TAC);;

 e(REWRITE_TAC[]);;

 e(REWRITE_TAC[]);;%

e(REPEAT GEN_TAC
  THEN DISCH_THEN REWRITE_THM
  THEN REWRITE_TAC[SUB_RIGHT_LESS]
  THEN REWRITE_TAC[num_CONV "1";ADD_CLAUSES;LESS_SUC_REFL]
  THEN COND_CASES_TAC
  THEN REWRITE_TAC[]);;

% 3rd subgoal: %

%e(REPEAT GEN_TAC);;
e(DISCH_THEN (REWRITE_THM o SYM));;
e(REPEAT STRIP_TAC);;%

e(REPEAT GEN_TAC
  THEN DISCH_THEN (REWRITE_THM o SYM)
  THEN REPEAT STRIP_TAC);;

% 4th subgoal: %

%e(REPEAT GEN_TAC);;
e(DISCH_THEN (REWRITE_THM o SYM));;
e(REPEAT STRIP_TAC);;
e(ASM_REWRITE_TAC[]);;%

e(REPEAT GEN_TAC
  THEN DISCH_THEN (REWRITE_THM o SYM)
  THEN REPEAT STRIP_TAC
  THEN ASM_REWRITE_TAC[]);;

% 5th subgoal: %

%e(REPEAT STRIP_TAC);;
e(FIRST_ASSUM MATCH_MP_TAC);;
e(EXISTS_TAC "m:num");;
e(ASM_REWRITE_TAC[]);;%

e(REPEAT STRIP_TAC
  THEN FIRST_ASSUM MATCH_MP_TAC
  THEN EXISTS_TAC "m:num"
  THEN ASM_REWRITE_TAC[]);;

% 6th subgoal: %

%e(REPEAT STRIP_TAC);;
e(FIRST_ASSUM MATCH_MP_TAC);;
e(EXISTS_TAC "n1:num");;
e(FIRST_ASSUM (REWRITE_THM o SYM));;
e(ASM_REWRITE_TAC[]);;%

e(REPEAT STRIP_TAC
  THEN FIRST_ASSUM MATCH_MP_TAC
  THEN EXISTS_TAC "n1:num"
  THEN FIRST_ASSUM (REWRITE_THM o SYM)
  THEN ASM_REWRITE_TAC[]);;

% 7th subgoal: %

%e(REPEAT GEN_TAC);;
e(DISCH_THEN (REWRITE_THM o SYM));;
e(REPEAT STRIP_TAC);;
e(FIRST_ASSUM (REWRITE_THM o SYM));;
e(ASM_REWRITE_TAC[]);;%

e(REPEAT GEN_TAC
  THEN DISCH_THEN (REWRITE_THM o SYM)
  THEN REPEAT STRIP_TAC
  THEN FIRST_ASSUM (REWRITE_THM o SYM)
  THEN ASM_REWRITE_TAC[]);;

% 8th subgoal: %

%e(REPEAT GEN_TAC);;
e(DISCH_THEN (REWRITE_THM o SYM));;
e(REPEAT STRIP_TAC);;%

e(REPEAT GEN_TAC
  THEN DISCH_THEN (REWRITE_THM o SYM)
  THEN REPEAT STRIP_TAC);;

let cycling = top_thm();;
print_vcg_thm cycling;;
%
|- [[ program
         procedure pedal(;n,m);
            global ;
            pre  true;
            post true;
            calls pedal with n < ^n /\ m = ^m;
            calls coast with n < ^n /\ m < ^m;
            recurses with n < ^n;

            if 0 < n
               then if 0 < m then coast(;n - 1,m - 1) else skip fi;
                    pedal(;n - 1,m)
               else skip
            fi
         end procedure;
         procedure coast(;n,m);
            global ;
            pre  true;
            post true;
            calls pedal with n = ^n /\ m = ^m;
            calls coast with n = ^n /\ m < ^m;
            recurses with m < ^m;

            pedal(;n,m); if 0 < m then coast(;n,m - 1) else skip fi
         end procedure;

         pedal(;7,12)
      end program
      [true] ]]
%

