% ================== %
% THE SUNRISE SYSTEM %
%       \ | /        %
%     ---_*_---      %
% ================== %

let new_ax n t = new_axiom (n,t);;
let new_def n t = new_definition (n,t);;
let new_infix_def n t = new_infix_definition (n,t);;
let new_prim_rec_def n t = new_prim_rec_definition (n,t);;
let new_infix_prim_rec_def n t = new_infix_prim_rec_definition (n,t);;
let new_list_rec_def n t = new_list_rec_definition (n,t);;
let new_infix_list_rec_def n t = new_infix_list_rec_definition (n,t);;
let new_rec_def n thm t = new_recursive_definition false thm n t;;
let new_infix_rec_def n thm t = new_recursive_definition true thm n t;;

let save_theorem n thm = save_thm (n,thm);;

let new_rec_type name form_string =
  let axiom = define_type (name ^ `_Axiom`) (name ^ ` = ` ^ form_string)
  in
  let induct = save_theorem (name ^ `_induct`) (prove_induction_thm axiom)
  in
  let cases = save_theorem (name ^ `_cases`) (prove_cases_thm induct)
  in
  let one_one = save_theorem (name ^ `_one_one`)
                             (prove_constructors_one_one axiom)
  in
  let distinct_list1 = CONJUNCTS (prove_constructors_distinct axiom) ? [] in
  let distinct_list2 = map (GEN_ALL o NOT_EQ_SYM o SPEC_ALL) distinct_list1 in
  let distinct = save_theorem (name ^ `_distinct`)
                              ((LIST_CONJ (distinct_list1 @ distinct_list2))
                               ? TRUTH)
  in
  (axiom,induct,cases,one_one,distinct) ;;

