
% --------------------------------------------------------------------- %
% Load the progress semantics rules.                                    %
% --------------------------------------------------------------------- %

let C_calls_rules,C_calls_ind =
    let rules,ind = CONJ_PAIR C_calls_DEF in CONJUNCTS rules,ind;;
let M_calls_rules,M_calls_ind =
    let rules,ind = CONJ_PAIR M_calls_DEF in CONJUNCTS rules,ind;;


% --------------------------------------------------------------------- %
% Tactics for the rules.						%
% --------------------------------------------------------------------- %

let C_CALLS_TAC = FIRST (map RULE_TAC C_calls_rules);;
let [SEQ1_CALLS_TAC;SEQ2_CALLS_TAC;IF_T_CALLS_TAC;IF_F_CALLS_TAC;
     WHILE1_CALLS_TAC;WHILE2_CALLS_TAC;CALL_CALLS_TAC] =
    map RULE_TAC C_calls_rules;;

let M_CALLS_TAC = FIRST (map RULE_TAC M_calls_rules);;
let [SINGLE_CALL_TAC;MULTIPLE_CALLS_TAC] = map RULE_TAC M_calls_rules;;

% --------------------------------------------------------------------- %
% Rule induction tactics.                                               %
% --------------------------------------------------------------------- %

let C_CALLS_INDUCT_TAC = RULE_INDUCT_THEN C_calls_ind
                           STRIP_ASSUME_TAC STRIP_ASSUME_TAC;;
let M_CALLS_INDUCT_TAC = RULE_INDUCT_THEN M_calls_ind
                           STRIP_ASSUME_TAC STRIP_ASSUME_TAC;;


let mk_str_ind_tac str_ind_thm = RULE_INDUCT_THEN str_ind_thm
                                 STRIP_ASSUME_TAC STRIP_ASSUME_TAC;;

let C_CALLS_STR_INDUCT_TAC = mk_str_ind_tac C_calls_str_induct;;
let M_CALLS_STR_INDUCT_TAC = mk_str_ind_tac M_calls_str_induct;;

