
% ========================================================= %
% Now we define the substitution of an assertion-language   %
% expression for the free occurrences of a variable within  %
% another assertion-language expression.                    %
% ========================================================= %


new_special_symbol `<|v`;;

let v_subst = 
    new_infix_definition
    (`v_subst`,
     "$<|v v (pr:vexp # string) = v <||v (BND (FST pr) (SND pr) IDENT_SS)");;


new_special_symbol `<|a`;;

let a_subst = 
    new_infix_definition
    (`a_subst`,
     "$<|a a (pr:vexp # string) = a <||a (BND (FST pr) (SND pr) IDENT_SS)");;


% We define (s <|s (e,x)) as the state resulting from replacing the %
% value of x in s by the value of e in s.                           %

new_special_symbol `<|s`;;

let replace = new_infix_definition
 (`replace`,
  "$<|s s (pr:vexp # string) = BND (V (FST pr) s) (SND pr) s");;


let v_subst_THM =
 prove_thm
  (`v_subst_THM`,
   "!e x s v. V (v <|v (e,x)) s = V v (s <|s (e,x))",
   REWRITE_TAC[replace;v_subst;v_ss_subst_THM;BND_SS_THM;IDENT_SS_over_THM]
  );;

%
g "!e x s v. V (v <|v (e,x)) s = V v (s <|s (e,x))";;
e(REWRITE_TAC[replace;v_subst;v_ss_subst_THM]);;
e(REWRITE_TAC[BND_SS_THM]);;
e(REWRITE_TAC[IDENT_SS_over_THM]);;
%


let a_subst_THM =
 prove_thm
  (`a_subst_THM`,
   "!a e x s. A (a <|a (e,x)) s = A a (s <|s (e,x))",
   REWRITE_TAC[replace;a_subst;a_ss_subst_THM;BND_SS_THM;IDENT_SS_over_THM]
  );;


% a_subst_THM:
g "!a e x s. A (a <|a (e,x)) s = A a (s <|s (e,x))";;
e(REWRITE_TAC[replace;a_subst]);;
e(REWRITE_TAC[a_ss_subst_THM]);;
e(REWRITE_TAC[BND_SS_THM]);;
e(REWRITE_TAC[IDENT_SS_over_THM]);;
%
