% file to load the vcg pretty-printer %

% The following loads in the whole library; but this is too much,
includes the whole prettyprinter compiler which we don't need, and
also installs the new pretty-printer as the standard HOL printer,
which is incredibly slow.

load_library `prettyp`;;

So instead, we do the following:
%

loadf (library_pathname() ^ `/prettyp/PP_printer`);;

let path st = library_pathname() ^ `/prettyp/PP_hol/` ^ st
and flag = get_flag_value `print_lib`
in  map (\st. load(path st, flag))
        [`hol_trees`;
         `precedence`;
         `hol_type_pp`;
         `hol_term_pp`;
         `hol_thm_pp`;
         `new_printers`];;

set_search_path( (sunrise_dir ^ `vcg_prettyp/`)
                . `/vcg_prettyp/`
                . search_path());;
loadf `finite_sets_pp`;;
%
compilef `vcg_pp`;;
%
loadf `vcg_pp`;;

let print_vcg_term t =

   % : (term -> void) %

   pp (vcg_rules_fun then_try
       finite_sets_rules_fun then_try
       hol_term_rules_fun then_try
       hol_type_rules_fun) `term` [] (pp_convert_term t);;

let print_vcg_thm t =

   % : (thm -> void) %

   pp (vcg_rules_fun then_try
       finite_sets_rules_fun then_try
       hol_thm_rules_fun then_try
       hol_term_rules_fun then_try
       hol_type_rules_fun) `thm` [] (pp_convert_thm t);;

%
Execute the following to install this pretty-printer as the standard
HOL printer.

top_print print_vcg_term;;
top_print print_vcg_thm;;
assignable_print_term := print_vcg_term;;
%
