% file to make a vcg parser %

load_library `prettyp`;;

set_search_path( (sunrise_dir ^ `vcg_prettyp/`)
                . `/vcg_prettyp/`
                . search_path());;

PP_to_ML false `vcg` ``;;
%
Run time: 4216.9s
Garbage collection time: 223.6s
%

compilef `vcg_pp`;;

loadt `vcg_pp`;;


let print_vcg_term t =

   % : (term -> void) %

   pp (vcg_rules_fun then_try
       hol_term_rules_fun then_try
       hol_type_rules_fun) `term` [] (pp_convert_term t);;

let print_vcg_thm t =

   % : (thm -> void) %

   pp (vcg_rules_fun then_try
       hol_thm_rules_fun then_try
       hol_term_rules_fun then_try
       hol_type_rules_fun) `thm` [] (pp_convert_thm t);;


top_print print_vcg_term;;
top_print print_vcg_thm;;
assignable_print_term := print_vcg_term;;

%
top_print (\t. pp (hol_term_rules_fun then_try
                   hol_type_rules_fun) `term` [] (pp_convert_term t));;

((pp (vcg_rules_fun then_try
      hol_term_rules_fun then_try
      hol_type_rules_fun)  `term` [(`DEBUG`,0)]) o pp_convert_term) [[ 7 ]];;

let f1 = \a. (case a of `FIRST` . 0 | `SEC` . 1) ? 100;;
f1 `FIRST`;;
f1 `SEC`;;
f1 `THIRD`;;
%

"DSEQ (DSEQ d1 d2) d3";;
"DSEQ d1 (DSEQ d2 d3)";;

"PROC `f` [VAR `x` 0] [VAR `a` 0] AFALSE ATRUE SKIP";;
"PROC `f` vs glbs AFALSE ATRUE SKIP";;
"PROC p vs glbs AFALSE ATRUE SKIP";;


pp_convert_term [[ 7 ]];;
[[ 7 ]];;

pp_convert_term [[ x+y ]];;

[[ 7 ]];;
[[ x ]];;
[[ ++x ]];;
[[ x - ++y ]];;
[[ x - ++y +99 ]];;
[[ x = ++y +99 ]];;
[[ x = ++y +99 /\ y-7<^a \/ 0=1 ]];;
[[ x = x+y+99 /\ y-7<^a /\ 0=1 ]];;
[[ x = x+(y+99) /\ y-7<^a /\ 0=1 ]];;

pp_convert_term [[ x:=x+1 ]];;

[[ skip ]];;
[[ abort ]];;
[[ x:=x+1 ]];;
[[ if a=0 then skip else abort fi ]];;
[[ skip; abort ]];;
[[ skip; x:=1; y:=2; abort ]];;
[[ skip; x:=1; y:=2; z:=3; abort ]];;
[[ skip; x:=1; y:=2; z:=3; x:=1; y:=2; z:=3; x:=1; y:=2; z:=3; x:=1; y:=2; z:=3; abort ]];;
[[ if 0 < (b+b) - (4+a+c)
   then d := (b+b) - (4+a+c)
   else d := (4+a+c) - (b+b)
   fi ]];;
[[ assert !a. ?b. !c. 0 < (b+b) - (4+a+c) /\ (a<b => true | false)
   while d = (b+b) - (4+a+c)
   do d := (4+a+c) - (b+b) + (4+a+c) - (b+b)
   od ]];;
[[ super(;7) ]];;
[[ triangle(x;7,y) ]];;
[[ triangle(x;) ]];;
[[ triangle(x,y;) ]];;
[[ triangle(;) ]];;
[[ super(z,c,x;7,x,++y,a+b+c,(b+b) - (4+a+c),d-e+f-g+h-i) ]];;
g [[ {true} skip {false} / empty ]];;
"CSPEC(ATRUE,SKIP,AFALSE,mkenv (PROC `` [] [] AFALSE ATRUE ABORT)r)";;

print_vcg_term "CSPEC(ATRUE,SKIP,AFALSE,r)";;
print_term "CSPEC(ATRUE,SKIP,AFALSE,r)";;


pp_convert_term "(AFALSE,SKIP,ATRUE)";;


((pp vcg_rules_fun `term` [(`DEBUG`,0)]) o pp_convert_term) [[ super(7) ]];;
((pp hol_term_rules_fun `term` []) o pp_convert_term) [[ super(7) ]];;
pp_convert_term [[ super(7) ]];;

pp_convert_term [[ triangle(7,x) ]];;
((pp vcg_rules_fun `term` [(`DEBUG`,0)]) o pp_convert_term) [[ triangle(7,x) ]];;

[[ super(7,x,++y,a+b+c,9<0,(b+b) - (4+a+c),d-e+f-g+h-i) ]];;

let test = "1 INSERT (2 INSERT (3 INSERT (4 INSERT (5 INSERT
             (6 INSERT EMPTY)))))";;
set_margin 15;;
test;;
set_margin 14;;
test;;
set_margin 12;;
test;;
set_margin 72;;

"(1,2) INSERT ((3,4) INSERT EMPTY)";;
(REWRITE_RULE[IN_INSERT;NOT_IN_EMPTY] o ASSUME)
    "(2,2) IN ((1,2) INSERT ((3,4) INSERT EMPTY))";;
