prettyprinter vcg =


declarations
   prec_val = {
           \symb. case symb
                  of `INC`    . 0
                   | `PLUS`   . 2
                   | `MINUS`  . 2
                   | `MULT`   . 1
                   | `EQ`     . 3
                   | `LESS`   . 3
                   | `LLESS`  . 3
                   | `AND`    . 4
                   | `OR`     . 5
                   | `NOT`    . 0

                   | `APLUS`  . 2
                   | `AMINUS` . 2
                   | `AMULT`  . 1
                   | `AEQ`    . 3
                   | `ALESS`  . 3
                   | `ALLESS` . 3
                   | `AAND`   . 5
                   | `AOR`    . 6
                   | `ANOT`   . 0
                   | `AIMP`   . 7
                   | `AEQB`   . 4
                   | `ACOND`  . 8
                   | `ACLOSE` . 0
                   | `AFORALL`. 9
                   | `AEXISTS`. 9
          };

   arity = {
           \symb. case symb
                  of `NUM`    . 1
                   | `PVAR`   . 1
                   | `INC`    . 1
                   | `PLUS`   . 2
                   | `MINUS`  . 2
                   | `MULT`   . 2
                   | `EQ`     . 2
                   | `LESS`   . 2
                   | `LLESS`  . 2
                   | `AND`    . 2
                   | `OR`     . 2
                   | `NOT`    . 1
                   | `SKIP`   . 0
                   | `ABORT`  . 0
                   | `ASSIGN` . 2
                   | `SEQ`    . 2
                   | `IF`     . 3
                   | `WHILE`  . 4
                   | `CALL`   . 3

                   | `ANUM`   . 1
                   | `AVAR`   . 1
                   | `APLUS`  . 2
                   | `AMINUS` . 2
                   | `AMULT`  . 2
                   | `ATRUE`  . 0
                   | `AFALSE` . 0
                   | `AEQ`    . 2
                   | `ALESS`  . 2
                   | `ALLESS` . 2
                   | `AAND`   . 2
                   | `AOR`    . 2
                   | `ANOT`   . 1
                   | `AIMP`   . 2
                   | `AEQB`   . 2
                   | `ACOND`  . 3
                   | `ACLOSE` . 1
                   | `AFORALL`. 2
                   | `AEXISTS`. 2

                   | `PROC`.    9
                   | `DSEQ`.    2
                   | `DEMPTY`.  0
                   | `PROG`.    2
                   | `M_calls_TERM`.  1
                   | `C_calls_TERM`.  1
                   | `REC_PROGRESS`.  1
                   | `PATH_PROGRESS`. 1
                   | `BODY_PROGRESS`. 1
                   | `PRE_PROGRESS`.  1
                   | `CPROGRESS`.     1
                   | `PSPEC`.   1
                   | `CSPEC`.   1
                   | `TCSPEC`.  1
                   | `PCSPEC`.  1
                   | `BSPEC`.   1
                   | `ES_SPEC`. 1
                   | `ESPEC`  . 1
                  ? 1000
          };

   prec = {bound_number `prec`};

   prec_of = {\meta. apply1 prec_val (bound_name meta)};

   prec_test = {\meta. apply2 (curry $<) (prec_of meta) prec};

   prog_op = {
                   \op. op is_a_member_of [`NUM`;`PVAR`;`INC`;`PLUS`;`MINUS`;
                                           `MULT`;`EQ`;`LESS`;`LLESS`;
                                           `AND`;`OR`;`NOT`;
                                           `SKIP`;`ABORT`;`ASSIGN`;`SEQ`;
                                           `IF`;`WHILE`;`CALL`]
             };

   assn_op = {
              \op. op is_a_member_of [`ANUM`;`AVAR`;`APLUS`;`AMINUS`;`AMULT`;
                                      `ATRUE`;`AFALSE`;`AEQ`;`ALESS`;`ALLESS`;
                                      `AAND`;`AOR`;`ANOT`;`AIMP`;`AEQB`;
                                      `ACOND`;`ACLOSE`;`AFORALL`;`AEXISTS`]
             };

   decl_op = {
              \op. op is_a_member_of [`PROC`;`DSEQ`;`DEMPTY`;`PROG`;
                                      `PSPEC`;`CSPEC`;`TCSPEC`;`PCSPEC`;
                                      `BSPEC`;`ES_SPEC`;`ESPEC`;
                                      `CPROGRESS`;`PRE_PROGRESS`;
                                      `BODY_PROGRESS`;
                                      `PATH_PROGRESS`;`REC_PROGRESS`;
                                      `C_calls_TERM`;`M_calls_TERM`]
             };

   arity_eq = {
               \op args. apply2 (\x y. length x = arity y)
                                (bound_children args)
                                (bound_name op)
              };

   prog_comb_test = {
                     \op args.
                        \params pbind.
                           if (prog_op op params pbind)
                              then (arity_eq op args params pbind)
                              else false
                    };

   assn_comb_test = {
                     \op args.
                        \params pbind.
                           if (assn_op op params pbind)
                              then (arity_eq op args params pbind)
                              else false
                    };

   decl_comb_test = {
                     \op args.
                        \params pbind.
                           if (decl_op op params pbind)
                              then (arity_eq op args params pbind)
                              else false
                    };

end declarations


abbreviations
   symb = {
           \symb. case symb
                  of `INC`    . `++`
                   | `PLUS`   . `+`
                   | `MINUS`  . `-`
                   | `MULT`   . `*`
                   | `EQ`     . `=`
                   | `LESS`   . `<`
                   | `LLESS`  . `<<`
                   | `AND`    . `/\`
                   | `OR`     . `\/`
                   | `NOT`    . `~`
                   | `SKIP`   . `skip`
                   | `ABORT`  . `abort`

                   | `APLUS`  . `+`
                   | `AMINUS` . `-`
                   | `AMULT`  . `*`
                   | `ATRUE`  . `true`
                   | `AFALSE` . `false`
                   | `AEQ`    . `=`
                   | `ALESS`  . `<`
                   | `ALLESS` . `<<`
                   | `AAND`   . `/\`
                   | `AOR`    . `\/`
                   | `ANOT`   . `~`
                   | `AIMP`   . `==>`
                   | `AEQB`   . `=`
                   | `ACLOSE` . `close`
                   | `AFORALL`. `!`
                   | `AEXISTS`. `?`
          };

   max_prec = {apply0 10};

   min_prec = {apply0  0};

end abbreviations


rules

   'term'::term(|*prog|[COMB(<>,**args)]CONST(***node(),**)) where
               {prog_comb_test `node` `args`} ->
           [<h 1> "[[" 'prog'::*prog with prec := max_prec end with "]]"];

   'term'::|*prog|[COMB(<>,**args)]CONST(***node(),**) where
               {prog_comb_test `node` `args`} ->
           [<h 1> "[[" 'prog'::*prog with prec := max_prec end with "]]"];

   'term'::term(|*prog|[COMB(<>,**args)]CONST(***node(),**)) where
               {assn_comb_test `node` `args`} ->
           [<h 1> "[[" [<h 0> "{" 'prog'::*prog with prec := max_prec end with
                              "}"] "]]"];

   'term'::|*prog|[COMB(<>,**args)]CONST(***node(),**) where
               {assn_comb_test `node` `args`} ->
           [<h 1> "[[" [<h 0> "{" 'prog'::*prog with prec := max_prec end with
                              "}"] "]]"];

   'term'::term(|*prog|[COMB(<>,**args)]CONST(***node(),**)) where
               {decl_comb_test `node` `args`} ->
           [<h 1> "[[" 'prog'::*prog with prec := max_prec end with "]]"];

   'term'::|*prog|[COMB(<>,**args)]CONST(***node(),**) where
               {decl_comb_test `node` `args`} ->
           [<h 1> "[[" 'prog'::*prog with prec := max_prec end with "]]"];

   'prog'::COMB(CONST(PSPEC(),**),
                COMB(COMB(CONST(#,#(),**),*pi),*q)) ->
           [<v 0,0>       'prog'::*pi with prec := max_prec end with
               [<h 0> "[" 'prog'::*q  with prec := max_prec end with "]"]];

   'prog'::COMB(CONST(CSPEC(),**),
                COMB(COMB(CONST(#,#(),**),*p),
                     COMB(COMB(CONST(#,#(),**),*c),
                          COMB(COMB(CONST(#,#(),**),*q),*r)))) ->
           [<hov 1,0,0> [<h 0> "[" 'prog'::*p with prec := max_prec end with "]"]
                <1,1,0>            'prog'::*c with prec := max_prec end with
                        [<h 0> "[" 'prog'::*q with prec := max_prec end with "]"]];

   'prog'::COMB(CONST(TCSPEC(),**),
                COMB(COMB(CONST(#,#(),**),*p),
                     COMB(COMB(CONST(#,#(),**),*c),*r))) ->
           [<hov 1,0,0> [<h 0> "[" 'prog'::*p with prec := max_prec end with "]"]
                <1,1,0>            'prog'::*c with prec := max_prec end with      ];

   'prog'::COMB(CONST(PCSPEC(),**),
                COMB(COMB(CONST(#,#(),**),*p),
                     COMB(COMB(CONST(#,#(),**),*c),
                          COMB(COMB(CONST(#,#(),**),*q),*r)))) ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*p with prec := max_prec end with "}"]
                <1,1,0>            'prog'::*c with prec := max_prec end with
                        [<h 0> "{" 'prog'::*q with prec := max_prec end with "}"]];

   'prog'::COMB(CONST(***spec(),**),
                COMB(COMB(CONST(#,#(),**),*p),
                          COMB(COMB(CONST(#,#(),**),*e),*q))) where
               {
                `spec` is_a_member_of [`BSPEC`;`ES_SPEC`;`ESPEC`]
               } ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*p with prec := max_prec end with "}"]
                <1,1,0>            'prog'::*e with prec := max_prec end with
                        [<h 0> "{" 'prog'::*q with prec := max_prec end with "}"]];

   'prog'::COMB(CONST(CPROGRESS(),**),
                COMB(COMB(CONST(#,#(),**),*a),
                     COMB(COMB(CONST(#,#(),**),*c),
                          COMB(COMB(CONST(#,#(),**),*p),
                               COMB(COMB(CONST(#,#(),**),*q),*r))))) ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*a with prec := max_prec end with "}"]
                <1,1,0>            'prog'::*c with prec := max_prec end with
                        [<h 1> "->" 'string'::*p]
                        [<h 0> "{" 'prog'::*q with prec := max_prec end with "}"]];

   'prog'::COMB(CONST(PRE_PROGRESS(),**),
                COMB(COMB(CONST(#,#(),**),*a),
                     COMB(COMB(CONST(#,#(),**),*c),*r))) ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*a with prec := max_prec end with "}"]
                <1,1,0>            'prog'::*c with prec := max_prec end with
                        [<h 1> "->" "pre"]];

   'prog'::COMB(CONST(BODY_PROGRESS(),**),
                COMB(COMB(CONST(#,#(),**),*a),
                     COMB(COMB(CONST(#,#(),**),*c),
                          COMB(COMB(CONST(#,#(),**),*calls),*r)))) ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*a with prec := max_prec end with "}"]
                <1,1,0>            'prog'::*c with prec := max_prec end with
                        [<h 1> "->" 'calls'::*calls]];

   'prog'::COMB(CONST(PATH_PROGRESS(),**),
                COMB(COMB(CONST(#,#(),**),*a),
                     COMB(COMB(CONST(#,#(),**),*p1),
                          COMB(COMB(CONST(#,#(),**),*ps),
                               COMB(COMB(CONST(#,#(),**),*p2),
                                    COMB(COMB(CONST(#,#(),**),*q),*r)))))) ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*a with prec := max_prec end with "}"]
                        [<hov 0,0,0> 'string'::*p1
                                     [<h 0> "-<" 'string'::*ps ">"]
                                     [<h 0> "->" 'string'::*p2]]
                        [<h 0> "{" 'prog'::*q with prec := max_prec end with "}"]];

   'prog'::COMB(CONST(REC_PROGRESS(),**),
                COMB(COMB(CONST(#,#(),**),*a),
                     COMB(COMB(CONST(#,#(),**),*p),
                          COMB(COMB(CONST(#,#(),**),*q),*r)))) ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*a with prec := max_prec end with "}"]
                        [<h 1> 'string'::*p "<-"]
                        [<h 0> "{" 'prog'::*q with prec := max_prec end with "}"]];

   'prog'::COMB(CONST(C_calls_TERM(),**),
                COMB(COMB(CONST(#,#(),**),*a),
                     COMB(COMB(CONST(#,#(),**),*c),*r))) ->
           [<hov 1,0,0> [<h 0> "{" 'prog'::*a with prec := max_prec end with "}"]
                <1,1,0>            'prog'::*c with prec := max_prec end with
                        [<h 0> "|"]];

   'prog'::COMB(CONST(M_calls_TERM(),**),
                COMB(COMB(CONST(#,#(),**),*p),*r)) ->
           [<h 1> 'string'::*p "|"];


   'string'::CONST(NIL(),**) ->
             [];

   'string'::[COMB(COMB(CONST(CONS(),**),*elems),<1..>)]CONST(NIL(),**) ->
                << **elems1   = {new_children butlast `elems`};
                   *last_elem = {new_children (\l. [last l]) `elems`} >>
             [<hv 0,+3,0> **[<h 0> **elems1 ","] *last_elem];

   'string'::CONST(***s(),**) ->
               << ***s0 = {new_name (implode o tl o butlast o explode) `s`} >>
             [<h 0> ***s0];


   'vars'::COMB(COMB(CONST(VAR(),**),CONST(***s(),**)),CONST(***n(),**)) where
              {`n` is_a_member_of [`0`]} ->
              << ***s0 = {new_name (implode o tl o butlast o explode) `s`} >>
          [<h 0> ***s0];

   'vars'::COMB(COMB(CONST(VAR(),**),CONST(***s(),**)),CONST(***n(),**)) ->
              << ***s0 = {new_name (implode o tl o butlast o explode) `s`} >>
          [<h 0> ***s0 ***n];

   'prog'::COMB(CONST(ANUM(),**),*n) ->
           [<h 0> 'term'::*n];

   'prog'::COMB(CONST(AVAR(),**),*x) ->
           [<h 0> 'vars'::*x];

   'prog'::COMB(CONST(ACLOSE(),**),*b) ->
           [<hv 1,3,0> "close" *b];

   'prog'::COMB(COMB(COMB(CONST(ACOND(),**),*b1),*b2),*b3) ->
           [<hv 1,3,0> [<h 0> "(" *b1 with
                                         prec := max_prec
                                      end with]
                       [<h 1> "=>" *b2 with
                                          prec := max_prec
                                       end with]
               <1,4,0> [<h 1> "|" [<h 0> *b3 with
                                                prec := max_prec
                                             end with ")"]]];

   'prog'::[COMB(COMB(CONST(***op(),**),**x),<1..: ***op>)]*b where
               {`op` is_a_member_of [`AFORALL`;`AEXISTS`]} ->
           [<h 0> if {prec_test `op`} then [] else [<h 0> "("]
                  [<hv 1,1,0> [<h 0> symb(***op) [<hv 1,0,0> 'vars'::**x] "."]
                              *b with
                                     prec := max_prec
                                 end with]
                  if {prec_test `op`} then [] else [<h 0> ")"]];

% old:
   'prog'::COMB(COMB(CONST(***op(),**),*x),*b) where
               {`op` is_a_member_of [`AFORALL`;`AEXISTS`]} ->
           [<h 0> if {prec_test `op`} then [] else [<h 0> "("]
                  [<hv 1,1,0> [<h 0> symb(***op) 'vars'::*x "."]
                              *b with
                                     prec := max_prec
                                 end with]
                  if {prec_test `op`} then [] else [<h 0> ")"]];
%

   'prog'::COMB(CONST(NUM(),**),*n) ->
           [<h 0> 'term'::*n];

   'prog'::COMB(CONST(PVAR(),**),*x) ->
           [<h 0> 'vars'::*x];

   'prog'::COMB(CONST(INC(),**),*x) ->
           [<h 0> "++" 'vars'::*x];

   'prog'::COMB(COMB(CONST(ASSIGN(),**),*x),*e) ->
           [<hv 1,3,0> [<h 1> 'vars'::*x ":="] *e];

   'prog'::COMB(COMB(CONST(SEQ(),**),
            [COMB(COMB(CONST(SEQ(),**),<1..>),*coms)]*com1),*com2) ->
              << **rev_coms = {new_children rev `coms`} >>
           [<hov 1,0,0> [<h 0> *com1 ";"]
                        **[<h 0> **rev_coms ";"]
                        *com2];

   'prog'::COMB(COMB(CONST(SEQ(),**),*c1),*c2) ->
           [<hov 1,0,0> [<h 0> *c1 ";"] *c2];

   'prog'::COMB(COMB(COMB(CONST(IF(),**),*b),*c1),*c2) ->
           [<hov 1,3,0> [<h 1> "if" *b]
                        [<hv 1,3,0> "then" *c1]
                        [<hv 1,3,0> "else" *c2]
                <1,0,0> "fi"];

   'prog'::COMB(COMB(COMB(COMB(CONST(WHILE(),**),*a),*pr),*b),*c) ->
           [<hov 1,0,0>
              [<hv 1,3,0> "assert" *a]
              <1,2,0> [<hv 1,3,0> "with" *pr]
              [<hv 1,3,0> "while" *b <1,0,0> "do"]
              <1,3,0> *c
              "od"];

   'prog'::COMB(COMB(COMB(CONST(CALL(),**),*p),*xs),*es) ->
           [<hv 0,3,0> 'string'::*p
                       [<h 0> "(" 'vars'::*xs ";" 'args'::*es ")"]];

   'prog'::COMB(COMB(COMB(COMB(COMB(COMB(COMB(COMB(COMB(CONST(PROC(),**),
                     *p),*vars),*vals),*glbs),*pre),*post),*calls),*rec),*c) ->
           [<hov 1,3,0>
              [<hv 1,3,0> "procedure" 'string'::*p <0,3,0>
                          [<h 0> "(" 'vars'::*vars ";" 'vars'::*vals ");"]]
              [<hv 1,3,0> "global" [<h 0> 'vars'::*glbs ";"]]
              [<hv 2,3,0>  "pre" [<h 0> *pre ";"]]
              [<hv 1,3,0> "post" [<h 0> *post ";"]]
              [<hv 1,3,0> 'calls'::*calls]
              [<hv 1,3,0> "recurses with" [<h 0> *rec ";"]]
              <1,3,1> *c
              <1,0,0> [<h 1> "end" "procedure"]];

   'calls'::COMB(COMB(COMB(CONST(BND(),**),*a),*p),*calls) ->
            [<v 0,0> [<hv 1,3,0> "calls" 'string'::*p "with"
                                 [<h 0> 'prog'::*a ";"]]
                     *calls];

   'calls'::ABS(*p,CONST(AFALSE(),**)) ->
            [];

   'prog'::COMB(COMB(CONST(DSEQ(),**),*d1),*d2) ->
           [<hv 1,0,0> [<h 0> *d1 ";"] *d2];

   'prog'::CONST(DEMPTY(),**) ->
           [<hv 1,0,0> "empty"];

   'prog'::COMB(COMB(CONST(PROG(),**),*d),*c) ->
           [<hov 1,3,0> "program"
                        [<h 0> *d ";"]
                <1,3,1> *c
                <1,0,0> [<h 1> "end" "program"]];

   'vars'::CONST(NIL(),**) ->
           [];

   'vars'::[COMB(COMB(CONST(CONS(),**),*elems),<1..>)]CONST(NIL(),**) ->
              << **elems1   = {new_children butlast `elems`};
                 *last_elem = {new_children (\l. [last l]) `elems`} >>
           [<hv 0,+3,0> **[<h 0> **elems1 ","] *last_elem];

   'args'::CONST(NIL(),**) ->
           [];

   'args'::[COMB(COMB(CONST(CONS(),**),*elems),<1..>)]CONST(NIL(),**) ->
              << **elems1   = {new_children butlast `elems`};
                 *last_elem = {new_children (\l. [last l]) `elems`} >>
           [<hv 0,+3,0> **[<h 0> 'prog'::**elems1 ","] 'prog'::*last_elem];

   'prog'::CONST(NIL(),**) ->
           [<h 0> "<>"];

   'prog'::[COMB(COMB(CONST(CONS(),**),*elems),<1..>)]CONST(NIL(),**) ->
              << **elems1   = {new_children butlast `elems`};
                 *last_elem = {new_children (\l. [last l]) `elems`} >>
           [<hv 0,+3,0> "<" **[<h 0> **elems1 ","] *last_elem ">"];

   'prog'::[COMB(COMB(CONST(***op(),**),*exps),<1..:***op>)]*exp
              where {
                     `op` is_a_member_of [`PLUS`;`MULT`;`AND`;`OR`;
                                          `APLUS`;`AMINUS`;`AMULT`;
                                          `AAND`;`AOR`;`AIMP`;`AEQB`]
                    } ->
           [<h 0> if {prec_test `op`} then [] else [<h 0> "("]
                  [<hov 1,0,0>
                         **[<h 1> *exps with
                                           prec := {prec_of `op`}
                                        end with
                                  symb(***op)]
                         *exp with
                                 prec := {prec_of `op`}
                              end with]
                  if {prec_test `op`} then [] else [<h 0> ")"]];

   'prog'::COMB(COMB(CONST(***op(),**),*e1),*e2)
              where {
                     `op` is_a_member_of [`MINUS`;`EQ`;`LESS`;`LLESS`;
                                          `AEQ`;`ALESS`;`ALLESS`]
                    } ->
           [<h 0> if {prec_test `op`} then [] else [<h 0> "("]
                  [<hv 1,0,0>
                         *e1 with
                                prec := {prec_of `op`}
                             end with
                         symb(***op)
                         *e2 with
                                prec := {prec_of `op`}
                             end with]
                  if {prec_test `op`} then [] else [<h 0> ")"]];

   'prog'::COMB(CONST(***op(),**),*e)
              where {`op` is_a_member_of [`NOT`;`ANOT`;`ACLOSE`]} ->
           [<h 0> if {prec_test `op`} then [] else [<h 0> "("]
                  [<h 0> symb(***op)
                         *e with
                               prec := {prec_of `op`}
                            end with]
                  if {prec_test `op`} then [] else [<h 0> ")"]];

   'prog'::CONST(***op(),**)
              where {`op` is_a_member_of [`SKIP`;`ABORT`;`ATRUE`;`AFALSE`]} ->
           [<h 0> symb(***op)];

   'prog'::*x ->
           [<h 0> 'term'::*x];

   'vars'::*x ->
           [<h 0> 'term'::*x];

   'string'::*x ->
           [<h 0> 'term'::*x];

end rules


end prettyprinter
