


let FVa_REC_EQ =
 prove_thm
  (`FVa_REC_EQ`,
   "!r p vars vals glbs pre post calls rec c.
       WFenv_syntax r /\ (r p = vars,vals,glbs,pre,post,calls,rec,c) ==>
       (?t z. (FVa rec = t UNION SL z) /\
              (!x. (x IN t) ==> WFx x) /\ NOT_WFxs z /\
              ((rec = AFALSE) ==> (z = [])) /\
              (!v y. (rec = ALESS v (AVAR y)) ==> (z = [y])))",
   REPEAT STRIP_TAC
   THEN IMP_RES_TAC (AND2IMP WELL_FORMED_PROCEDURE_REC)
   THENL
    [ ASM_REWRITE_TAC[FVa_DEF;SUBSET]
      THEN EXISTS_TAC "EMPTY:var set"
      THEN EXISTS_TAC "[]:var list"
      THEN REWRITE_TAC[SET_LIST;UNION;IN;NOT_WFxs;aexp_distinct];

      EXISTS_TAC "FVv v"
      THEN EXISTS_TAC "[y:var]"
      THEN ASM_REWRITE_TAC[FVa_DEF;FVv_DEF;SET_LIST;NOT_WFxs]
      THEN REWRITE_TAC[aexp_distinct;aexp_one_one;vexp_one_one;CONS_11]
      THEN UNDISCH_LAST_TAC
      THEN REWRITE_TAC[SUBSET_DEF]
      THEN REPEAT STRIP_TAC
      THEN RES_TAC
      THEN IMP_RES_TAC WELL_FORMED_PROCEDURE_SYNTAX
      THEN IMP_RES_TAC WFxs_IS_WFx
    ]
  );;

%< FVa_REC_EQ:
g "!r p vars vals glbs pre post calls rec c.
       WFenv_syntax r /\ (r p = vars,vals,glbs,pre,post,calls,rec,c) ==>
       (?t z. (FVa rec = t UNION SL z) /\
              (!x. (x IN t) ==> WFx x) /\ NOT_WFxs z /\
              ((rec = AFALSE) ==> (z = [])) /\
              (!v y. (rec = ALESS v (AVAR y)) ==> (z = [y])))";;
e(REPEAT STRIP_TAC);;
e(IMP_RES_TAC (AND2IMP WELL_FORMED_PROCEDURE_REC));;

 e(ASM_REWRITE_TAC[FVa_DEF]);;
 e(EXISTS_TAC "EMPTY:var set");;
 e(EXISTS_TAC "[]:var list");;
 e(REWRITE_TAC[SET_LIST;UNION;IN;NOT_WFxs;aexp_distinct]);;

 e(EXISTS_TAC "FVv v");;
 e(EXISTS_TAC "[y:var]");;
 e(ASM_REWRITE_TAC[FVa_DEF;FVv_DEF;SET_LIST;NOT_WFxs]);;
 e(REWRITE_TAC[aexp_distinct]);;
 e(REWRITE_TAC[aexp_one_one;vexp_one_one;CONS_11]);;
 e(UNDISCH_LAST_TAC);;
 e(REWRITE_TAC[SUBSET_DEF]);;
 e(REPEAT STRIP_TAC);;
 e(RES_TAC);;
 e(IMP_RES_TAC WELL_FORMED_PROCEDURE_SYNTAX);;
 e(IMP_RES_TAC WFxs_IS_WFx);;
>%



let SUBSET_EQ_SOME =
 prove_thm
  (`SUBSET_EQ_SOME`,
   "!s u v.
        s SUBSET (u UNION v) /\
        (!x. (x IN u) ==> WFx x) /\
        (!x. (x IN v) ==> ~WFx x) ==>
        (?t z.
           (s = (t UNION SL z)) /\
           (t SUBSET u) /\
           (SL z SUBSET v))",
   SET_INDUCT_TAC
   THENL
    [ REWRITE_TAC[SUBSET]
      THEN REPEAT STRIP_TAC
      THEN EXISTS_TAC "EMPTY:var set"
      THEN EXISTS_TAC "[]:var list"
      THEN REWRITE_TAC[SET_LIST;UNION;SUBSET];

      REWRITE_TAC[SUBSET;IN_UNION]
      THEN REPEAT STRIP_TAC
      THEN FIRST_ASSUM (IMP_RES_TAC o AND2IMP o SPEC "u:var set")
      THENL
       [ EXISTS_TAC "(e:var) INSERT t"
         THEN EXISTS_TAC "z:var list";

         EXISTS_TAC "t:var set"
         THEN EXISTS_TAC "CONS (e:var) z"
       ]
      THEN ASM_REWRITE_TAC[SET_LIST;UNION;SUBSET]
      THEN ONCE_REWRITE_TAC[UNION_COMM]
      THEN ASM_REWRITE_TAC[UNION]
    ]
  );;

%< SUBSET_EQ_SOME
g "!s u v.
        s SUBSET (u UNION v) /\
        (!x. (x IN u) ==> WFx x) /\
        (!x. (x IN v) ==> ~WFx x) ==>
        (?t z.
           (s = (t UNION SL z)) /\
           (t SUBSET u) /\
           (SL z SUBSET v))";;
e(SET_INDUCT_TAC);;

 e(REWRITE_TAC[SUBSET]);;
 e(REPEAT STRIP_TAC);;
 e(EXISTS_TAC "EMPTY:var set");;
 e(EXISTS_TAC "[]:var list");;
 e(REWRITE_TAC[SET_LIST;UNION;SUBSET]);;

 e(REWRITE_TAC[SUBSET;IN_UNION]);;
 e(REPEAT STRIP_TAC);;

   e(FIRST_ASSUM (IMP_RES_TAC o AND2IMP o SPEC "u:var set"));;
   e(EXISTS_TAC "(e:var) INSERT t");;
   e(EXISTS_TAC "z:var list");;
   e(ASM_REWRITE_TAC[SET_LIST;UNION;SUBSET]);;

   e(FIRST_ASSUM (IMP_RES_TAC o AND2IMP o SPEC "u:var set"));;
   e(EXISTS_TAC "t:var set");;
   e(EXISTS_TAC "CONS (e:var) z");;
   e(ASM_REWRITE_TAC[SET_LIST;UNION;SUBSET]);;
   e(ONCE_REWRITE_TAC[UNION_COMM]);;
   e(ASM_REWRITE_TAC[UNION]);;
>%

%<
g "!r vars vals glbs pre post calls rec c vars' vals' glbs' pre' post'
    calls' rec' c' p1 p2 q x y z u.
     WFenv_syntax r /\
     (r p1 = vars,vals,glbs,pre,post,calls,rec,c) /\
     (r p2 = vars',vals',glbs',pre',post',calls',rec',c') /\
     (x = APPEND(APPEND vars vals)glbs) /\
     (y = APPEND(APPEND vars' vals')glbs') /\
     (FVa q SUBSET SL(APPEND y (logicals z))) /\
     (u IN SL(logicals z)) ==>
     (u IN FVa(call_progress p1 p2 q r))";;

e(REPEAT STRIP_TAC);;
e(REWRITE_TAC[call_progress]);;
e(ASM_REWRITE_TAC[]);;
e(CONV_TAC (DEPTH_CONV let_CONV));;
e(REWRITE_TAC[(SYM o ASSUME)"x = APPEND(APPEND vars vals)glbs :var list"]);;
e(REWRITE_TAC[(SYM o ASSUME)"y = APPEND(APPEND vars' vals')glbs' :var list"]);;
>%



%< FVa_call_progress_EQ

g "!r p' p vars vals glbs pre post calls rec c.
      WFenv_syntax r /\
      (r p = (vars,vals,glbs,pre,post,calls,rec,c)) ==>
      (?t z.
        (FVa (call_progress p' p rec r) = t UNION (SL z)) /\
        (!x. x IN t ==> WFx x) /\
        NOT_WFxs z /\
        ((rec = AFALSE) ==> (z = [])) /\
        (!v y. (rec = ALESS v(AVAR y)) ==> (z = [y])))";;

e(REPEAT STRIP_TAC);;
e(IMP_RES_TAC (AND2IMP FVa_REC));;
e(SUBGOAL_THEN "FVa(call_progress p' p rec r) SUBSET
                SL(APPEND (APPEND (APPEND ((FST)(r p')) ((FST o SND)(r p')))
                                  ((FST o SND o SND)(r p')))
                          (logicals z))"
      ASSUME_TAC);;

 e(MATCH_MP_TAC (SPECL["r:env";
                       "(FST)((r:env) p')";
                       "(FST o SND)((r:env) p')";
                       "(FST o SND o SND)((r:env) p')";
                       "(FST o SND o SND o SND)((r:env) p')";
                       "(FST o SND o SND o SND o SND)((r:env) p')";
                       "(FST o SND o SND o SND o SND o SND)((r:env) p')";
                       "(FST o SND o SND o SND o SND o SND o SND)((r:env) p')";
                       "(SND o SND o SND o SND o SND o SND o SND)((r:env) p')";
                       "vars:var list";"vals:var list";"glbs:var list";
                       "pre:aexp";"post:aexp";"calls:prog_env";
                       "rec:aexp";"c:cmd";"p':string";"p:string";"rec:aexp";
                       "APPEND (APPEND ((FST)(r p')) ((FST o SND)(r p')))
                               ((FST o SND o SND)((r:env) p'))";
                       "APPEND (APPEND vars vals) glbs :var list";
                       "z:var list"]
        FVa_call_progress));;
 e(ASM_REWRITE_TAC[(SYM o SPEC_ALL)ENV_TUPLE]);;
let st5 = get_state();;
set_state st5;;
 e(POP_ASSUM (ASSUME_TAC o ONCE_REWRITE_RULE[SL_APPEND]));;
 e(SUBGOAL_THEN
        "!x. (x IN SL (APPEND
                       (APPEND(FST(r p'))((FST o SND)(r p')))
                       ((FST o (SND o SND))((r:env) p')))) ==>
             WFx x"
        ASSUME_TAC);;

  e(REPEAT STRIP_TAC);;
  e(UNDISCH_TAC "(r:env) p = vars,vals,glbs,pre,post,calls,rec,c");;
  e(ASSUME_TAC (ISPEC "(r:env) p'" ENV_TUPLE));;
  e(IMP_RES_TAC WELL_FORMED_PROCEDURE_SYNTAX);;
  e(DISCH_TAC);;
  e(IMP_RES_TAC WFxs_IS_WFx);;

 e(SUBGOAL_THEN
        "!x. (x IN SL (logicals z)) ==>
             ~WFx x"
        ASSUME_TAC);;

  e(GEN_TAC THEN DISCH_TAC);;
  e(IMP_RES_TAC logicals_IS_NOT_WFx);;

 e(IMP_RES_TAC (AND2IMP SUBSET_EQ_SOME));;
 e(EXISTS_TAC "t:var set");;
 e(EXISTS_TAC "z':var list");;

e(IMP_RES_TAC (AND2IMP WELL_FORMED_PROCEDURE_REC));;

 e(EXISTS_TAC "EMPTY:var set");;
 e(EXISTS_TAC "[]:var list");;
 e(ASM_REWRITE_TAC[SET_LIST;UNION;IN;NOT_WFxs]);;
 e(REWRITE_TAC[aexp_distinct]);;
 e(REWRITE_TAC[call_progress]);;
 e(REWRITE_TAC[call_progress]);;
 e(ONCE_REWRITE_TAC[ISPEC "(r:env) p" ENV_TUPLE]);;
 e(CONV_TAC (DEPTH_CONV let_CONV));;
 e(ASM_REWRITE_TAC[o_THM]);;
 e(DEFINE_NEW_VAR "(x:var list) = APPEND (APPEND vars vals) glbs");;
 e(FIRST_ASSUM (REWRITE_THM o SYM));;
 e(DEFINE_NEW_VAR "y = APPEND (APPEND (FST(r p')) (FST(SND(r p'))))
                              (FST(SND(SND((r:env) p'))))");;
 e(FIRST_ASSUM (REWRITE_THM o SYM));;
 e(REWRITE_TAC[FVa_DEF]);;
 e(COND_CASES_TAC);;

  e(REWRITE_TAC[FVa_DEF]);;

  e(REWRITE_TAC[FVa_a_subst]);;
  e(REWRITE_TAC[FVa_mk_foralls]);;
  e(REWRITE_TAC[FVa_DEF;UNION_EMPTY]);;
  e(REWRITE_TAC[FVa_a_subst]);;

e(IMP_RES_TAC WELL_FORMED_PROCEDURE_SYNTAX);;
e(POP_ASSUM (MP_TAC o SPEC "p2:string"));;
e(DISCH_THEN (\th1. DISCH_TAC THEN MP_TAC th1));;
e(FIRST_ASSUM REWRITE_THM);;
e(CONV_TAC (DEPTH_CONV let_CONV));;
e(REWRITE_TAC[(SYM o ASSUME)"(x:var list) = APPEND (APPEND vars vals) glbs"]);;
e(REWRITE_TAC[(SYM o ASSUME)"(y:var list) = APPEND (APPEND vars' vals') glbs'"]);;
e(DISCH_TAC);;
e(COND_CASES_TAC);; % two cases %

 e(REWRITE_TAC[FVa_DEF;EMPTY_SUBSET]);;

let st1 = get_state();;
set_state st1;;
 e(REWRITE_TAC[FVa_DEF;FVa_var_list_subst;FVa_mk_foralls;
                  IMAGE_UNION;UNION_SUBSET;UNION_DIFF]);;
 e(REWRITE_ALL_TAC[SUBSET_DEF]);;
 e(REWRITE_TAC[SL_APPEND]);;
 e(REWRITE_TAC[IN_IMAGE;IN_UNION;IN_DIFF]);;
 e(REPEAT STRIP_TAC);;  % 2 subgoals %

let st2 = get_state();;
set_state st2;;
  e(DISJ1_TAC);;
  e(ASM_REWRITE_TAC[]);;
  e(RES_TAC);;
  e(MATCH_MP_TAC (REWRITE_RULE[AND_IMP_INTRO] BNDsR_MEMBER));;
  e(REWRITE_TAC[LENGTH_variants;LENGTH_logicals]);;
  e(MATCH_MP_TAC (REWRITE_RULE[AND_IMP_INTRO] BNDsR_MEMBER));;
  e(REWRITE_TAC[LENGTH_variants;LENGTH_logicals]);;
  e(POP_ASSUM (STRIP_ASSUME_TAC o REWRITE_RULE[SL_APPEND;IN_UNION]));;

   e(UNDISCH_TAC "~(x'':var) IN (SL y)");;
   e(ASM_REWRITE_TAC[]);;
   e(SUBGOAL_THEN "WFx x'''" ASSUME_TAC);;

    e(MATCH_MP_TAC WFxs_IS_WFx);;
    e(EXISTS_TAC "y:var list");;
    e(ASM_REWRITE_TAC[]);;
    e(IMP_RES_TAC WELL_FORMED_PROCEDURE_SYNTAX);;

    e(USE_IMP_THEN REWRITE_THM BNDsR_NOT_MATCH);;

     e(IMP_RES_THEN REWRITE_THM WFx_NOT_logicals);;

     e(REWRITE_TAC[I_THM]);;
     e(UNDISCH_TAC "(x''':var) IN SL y");;
     e(ASM_REWRITE_TAC[]);;
     e(DISCH_THEN REWRITE_THM);;

   e(POP_ASSUM MP_TAC);;
   e(ASM_REWRITE_TAC[]);;

let st3 = get_state();;
set_state st3;;
  e(DISJ2_TAC);;
  e(RES_TAC);;
  e(UNDISCH_LAST_TAC);;
  e(REWRITE_TAC[SL_APPEND;IN_UNION]);;
  e(ASM_REWRITE_TAC[]);;
  e(DISCH_TAC);;
  e(USE_IMP_THEN REWRITE_THM BNDsR_NOT_MATCH);;

   e(MP_TAC (SPECL["logicals x";"FVa q"] DISJOINT_variants));;
   e(ASM_REWRITE_TAC[]);;
   e(DISCH_TAC);;
   e(IMP_RES2_THEN REWRITE_THM IN_DISJOINT_IMP);;

   e(ASM_REWRITE_TAC[I_THM]);;
>%


let variant_NOT_WFx_UNION =
 prove_thm
  (`variant_NOT_WFx_UNION`,
   "!s t x.
      ~WFx x /\
      (!x. x IN s ==> WFx x) ==>
      (variant x (s UNION t) = variant x t)",
   REPEAT STRIP_TAC
   THEN MATCH_MP_TAC VAR_EQ
   THEN REWRITE_TAC[Base_variant]
   THEN ASSUME_TAC (SPECL["x:var";"t:var set"] variant_is_variant)
   THEN ASSUME_TAC (SPECL["x:var";"s UNION t:var set"] variant_is_variant)
   THEN SUBGOAL_THEN "~(variant x t IN (s UNION t))" ASSUME_TAC
   THENL
    [ REWRITE_TAC[IN_UNION;DE_MORGAN_THM]
      THEN CONJ_TAC
      THENL
       [ STRIP_TAC
         THEN RES_TAC
         THEN UNDISCH_LAST_TAC
         THEN ASM_REWRITE_TAC[WFx_variant];

         REWRITE_TAC[variant_not_in_set]
       ];

      ALL_TAC
    ]
   THEN SUBGOAL_THEN "~(variant x (s UNION t) IN t)" ASSUME_TAC
   THENL
    [ MP_TAC (SPECL["x:var";"s UNION t:var set"] variant_not_in_set)
      THEN REWRITE_TAC[IN_UNION;DE_MORGAN_THM]
      THEN STRIP_TAC;

      ALL_TAC
    ]
   THEN IMP_RES2_THEN ASSUME_TAC (AND2IMP variant_minimum_DEF)
   THEN IMP_RES_TAC (AND2IMP LESS_EQUAL_ANTISYM)
  );;

%< variant_NOT_WFx_UNION
g "!s t x.
      ~WFx x /\
      (!x. x IN s ==> WFx x) ==>
      (variant x (s UNION t) = variant x t)";;
e(REPEAT STRIP_TAC);;
e(MATCH_MP_TAC VAR_EQ);;
e(REWRITE_TAC[Base_variant]);;
e(ASSUME_TAC (SPECL["x:var";"t:var set"] variant_is_variant));;
e(ASSUME_TAC (SPECL["x:var";"s UNION t:var set"] variant_is_variant));;
e(SUBGOAL_THEN "~(variant x t IN (s UNION t))" ASSUME_TAC);;

 e(REWRITE_TAC[IN_UNION;DE_MORGAN_THM]);;
 e(CONJ_TAC);;

  e(STRIP_TAC);;
  e(RES_TAC);;
  e(UNDISCH_LAST_TAC);;
  e(ASM_REWRITE_TAC[WFx_variant]);;

  e(REWRITE_TAC[variant_not_in_set]);;

e(SUBGOAL_THEN "~(variant x (s UNION t) IN t)" ASSUME_TAC);;

 e(MP_TAC (SPECL["x:var";"s UNION t:var set"] variant_not_in_set));;
 e(REWRITE_TAC[IN_UNION;DE_MORGAN_THM]);;
 e(STRIP_TAC);;

e(IMP_RES2_THEN ASSUME_TAC (AND2IMP variant_minimum_DEF));;
e(IMP_RES_TAC (AND2IMP LESS_EQUAL_ANTISYM));;
>%


%<
g "!x p' p r vars vals glbs pre post calls rec c.
       WFenv_syntax r /\
       ~WFx x /\
       (r p = (vars,vals,glbs,pre,post,calls,rec,c)) /\
       (r p' = (vars',vals',glbs',pre',post',calls',rec',c')) ==>
       (variant x (FVa (call_progress p' p rec r)) =
        variant x (FVa rec))";;
e(REPEAT STRIP_TAC);;
e(UNDISCH_LAST_TAC);;
e(IMP_RES_TAC (AND2IMP FVa_REC_EQ));;
e(IMP_RES_TAC (AND2IMP WELL_FORMED_PROCEDURE_REC));;

 e(DISCH_TAC);;
 e(ASM_REWRITE_TAC[]);;
 e(IMP_RES2_THEN REWRITE_THM variant_NOT_WFx_UNION);;
 e(RES_TAC);;
 e(ASM_REWRITE_TAC[SET_LIST;variant_EMPTY]);;
 e(REWRITE_TAC[call_progress]);;
 e(ASM_REWRITE_TAC[]);;
 e(CONV_TAC (DEPTH_CONV let_CONV));;

e(REWRITE_TAC[call_progress]);;
e(ASM_REWRITE_TAC[call_progress]);;
%e(ONCE_REWRITE_TAC[ISPEC "(r:env) p" ENV_TUPLE]);;%
e(CONV_TAC (DEPTH_CONV let_CONV));;
e(COND_CASES_TAC);;

 e(REWRITE_TAC[A_DEF]);;

 e(REWRITE_TAC[a_subst_THM]);;
 e(REWRITE_TAC[A_mk_foralls]);;
 e(REWRITE_TAC[A_DEF]);;
 e(REPEAT STRIP_TAC);;
 e(RES_TAC);;
>%

%<
g "!x p' p r.
       (r p = (vars,vals,glbs,pre,post,calls,rec,c)) /\
       (r p' = (vars',vals',glbs',pre',post',calls',rec',c')) /\
       NOT_WFxs x ==>
       (variants x (FVa (call_progress p' p rec r)) =
        variants x (FVa rec))";;
e(REWRITE_TAC[CLOSE;A_DEF]);;
e(REPEAT GEN_TAC);;
e(STRIP_TAC);;
e(GEN_TAC);;
e(ASM_REWRITE_TAC[call_progress]);;
%e(ONCE_REWRITE_TAC[ISPEC "(r:env) p" ENV_TUPLE]);;%
e(CONV_TAC (DEPTH_CONV let_CONV));;
e(COND_CASES_TAC);;

 e(REWRITE_TAC[A_DEF]);;

 e(REWRITE_TAC[a_subst_THM]);;
 e(REWRITE_TAC[A_mk_foralls]);;
 e(REWRITE_TAC[A_DEF]);;
 e(REPEAT STRIP_TAC);;
 e(RES_TAC);;
>%
